import java.applet.Applet;
import java.net.URLConnection;
import java.net.URL;
import java.io.BufferedWriter;
import java.io.BufferedReader;
import java.io.OutputStreamWriter;
import java.io.InputStreamReader;
import java.lang.StringBuffer;

public class HTTPPost extends Applet {
    private char[] MBuffer=new char[8192];
    public String getAppletInfo() {
        return "Copyright (c) 2004 BMC Software.\nAll rights reserved.";
    }

    // Do an HTTP post. Returns a string with the response. The first character
    // is always present (to avoid having to throw exceptions across LiveConnect):
    //   0 indicating an error/exception occured;
    //   1 incicating success.
    // The remainder of the string is the actual response received from the web
    // server.
    //
    // Params are:
    //   url - destination URL for POST request.
    //   contenttype - content type string to be set into content-type header.
    //   payload - actual HTTP POST data.
    public String doPost(String url,String contenttype,String payload) {
        try {
            URLConnection connection=new URL(url).openConnection();
            connection.setDoInput(true);
            connection.setDoOutput(true);
            connection.setUseCaches(false);
            connection.setRequestProperty("Content-type",contenttype);
            BufferedWriter wrt=new BufferedWriter(new OutputStreamWriter(connection.getOutputStream(),"UTF-8"));
            wrt.write(payload);
            wrt.close();
            BufferedReader rd=new BufferedReader(new InputStreamReader(connection.getInputStream(),"UTF-8"));
            StringBuffer result=new StringBuffer();
            int readSize;
            while((readSize=rd.read(MBuffer,0,MBuffer.length))!=-1)
                result.append(MBuffer,0,readSize);
            rd.close();
            return result.toString();
        } catch(Exception ex) { // Don't let any checked or unchecked exceptions propagate.
            return "0"+ex.toString();
        }
    }
}
